/*-------------------------------------------------------------------------
 *
 * execdesc.h--
 *    plan and query descriptor accessor macros used by the executor
 *    and related modules.
 *
 *
 * Copyright (c) 1994, Regents of the University of California
 *
 * execdesc.h,v 1.1.1.1 1994/11/07 05:19:28 andrew Exp
 *
 *-------------------------------------------------------------------------
 */
#ifndef EXECDESC_H
#define EXECDESC_H

#include "nodes/parsenodes.h"
#include "nodes/plannodes.h"
#include "tcop/dest.h"

/* ----------------
 *	query descriptor 
 * ----------------
 */
typedef struct QueryDesc {
    int			operation;
    Query		*parsetree;
    Plan		*plantree;
    List		*arglist;
    List		*typelist;
    int			nargs;
    CommandDest		dest;
    int			count;		/* was feature.Count */
} QueryDesc;

#endif /*  EXECDESC_H  */
